import { Model } from "../../../shared";
import { removeEmptyChars } from "../../../utils";
export class Nft extends Model {
    /** The Metadata PDA account defining the NFT. */
    metadataAccount;
    /** The optional Metadata Edition PDA account associated with the NFT. */
    masterEditionAccount;
    /** The JSON metadata from the URI. */
    metadata;
    /** Data from the Metadata account. */
    updateAuthority;
    mint;
    name;
    symbol;
    uri;
    sellerFeeBasisPoints;
    creators;
    primarySaleHappened;
    isMutable;
    editionNonce;
    tokenStandard;
    collection;
    uses;
    /** Data from the MasterEdition account. */
    supply;
    maxSupply;
    constructor(metadataAccount, masterEditionAccount = null, metadata = null) {
        super();
        this.metadataAccount = metadataAccount;
        this.masterEditionAccount = masterEditionAccount;
        this.metadata = metadata;
        this.updateAuthority = metadataAccount.data.updateAuthority;
        this.mint = metadataAccount.data.mint;
        this.name = removeEmptyChars(metadataAccount.data.data.name);
        this.symbol = removeEmptyChars(metadataAccount.data.data.symbol);
        this.uri = removeEmptyChars(metadataAccount.data.data.uri);
        this.sellerFeeBasisPoints = metadataAccount.data.data.sellerFeeBasisPoints;
        this.creators = metadataAccount.data.data.creators;
        this.primarySaleHappened = metadataAccount.data.primarySaleHappened;
        this.isMutable = metadataAccount.data.isMutable;
        this.editionNonce = metadataAccount.data.editionNonce;
        this.tokenStandard = metadataAccount.data.tokenStandard;
        this.collection = metadataAccount.data.collection;
        this.uses = metadataAccount.data.uses;
        this.supply = masterEditionAccount?.data.supply ?? null;
        this.maxSupply = masterEditionAccount?.data.maxSupply ?? null;
    }
}
//# sourceMappingURL=Nft.js.map