import { ModuleClient, Plan } from "../../shared";
import { Nft } from "./";
import { ConfirmOptions, PublicKey } from '@solana/web3.js';
import { UploadMetadataInput, UploadMetadataOutput, CreateNftInput, CreateNftOutput, UpdateNftInput, UpdateNftOutput } from './operations';
export declare class NftClient extends ModuleClient {
    uploadMetadata(input: UploadMetadataInput, confirmOptions?: ConfirmOptions): Promise<UploadMetadataOutput>;
    planUploadMetadata(input: UploadMetadataInput, confirmOptions?: ConfirmOptions): Promise<Plan<undefined, UploadMetadataOutput>>;
    createNft(input: CreateNftInput, confirmOptions?: ConfirmOptions): Promise<{
        nft: Nft;
    } & CreateNftOutput>;
    findNft({ mint }: {
        mint: PublicKey;
    }): Promise<Nft>;
    updateNft(nft: Nft, input: Omit<UpdateNftInput, 'nft'>, confirmOptions?: ConfirmOptions): Promise<{
        nft: Nft;
    } & UpdateNftOutput>;
}
